function PopUpsAddButton(i)
--Add a button to PopUps[i], on the PopUp Button.
	local popbuttonindex=PopUps[i].options.popbuttonindex
	local x,y=PopUps[i].Quickslot[popbuttonindex]:GetPosition()
	PopUps[i].button=JackdawPlugins.Libs.NewButton{x=x+1,y=y+1,width=34,height=34,parent=PopUps[i].Window}
	PopUps[i].button:SetVisible(false)
--Assign Events to Buttons
PopUpsButtonEvents(i)
end

function PopUpsButtonEvents(i)
--Set to only be visible when UI is unlocked.
	--PopUps[i].button:SetWantsUpdates(true);
	PopUps[i].button:SetWantsKeyEvents(true);
	PopUps[i].button.KeyDown = function(sender, args)
	--When turbine fix that bug remove the code from here...
	if i==1 then
		if set==false then
		set=pcall(function () 
			if ( Plugins ["PopUps"] ~= nil ) then
				JackdawPlugins.Libs.echo("PopUps registered for save on unload")
				Plugins["PopUps"].Unload = function( sender, args )
					save()
					--Clear all the quickslots - saves a crash!
					for i=1, NumberOfBars do
						for j=1, #PopUps[i].Quickslot do
							PopUps[i].Quickslot[j]:SetShortcut(nil)
						end
					end
					JackdawPlugins.Libs.echo("Thank you for using Pop Up Bars!")
				end
			end
		end) end
	end 																													-- ...to here
		if (args.Action == 268435579) then
			--reveal or hide button
			PopUps[i].button:SetVisible(not PopUps[i].button:IsVisible())
			--roll out the PopUps, if the button is visible
			if PopUps[i].button:IsVisible() then
				PopUps[i]:Open()
			else
			--close em if not!
				PopUps[i]:Close()
			end
			if i==1 then
			save()
			end--I am going to attach this only to bar 1.
		end
	end

--Register button click to open the menu
	PopUps[i].button.MouseDown = function( sender, args )
	-- build the menu items in the context menu
		local contextMenu = Turbine.UI.ContextMenu();
		local contextMenuItems = contextMenu:GetItems();
		local addsubMenuItem = Turbine.UI.MenuItem( "Add a slot to "..PopUps[i].options.name,PopUps[i].options.length<15 ); --Maximum length 15
		addsubMenuItem.Click = function( sender, args )
			PopUps[i]:Change (1)
		end

		local takesubMenuItem = Turbine.UI.MenuItem( "Take a slot from "..PopUps[i].options.name,PopUps[i].options.length>2 ); --Minimum length 2
		takesubMenuItem.Click = function( sender, args )
			PopUps[i]:Change (-1)
		end

	local BarMenuItem = Turbine.UI.MenuItem("Add or Delete Bar")
		contextMenu.SubMenuItems = BarMenuItem:GetItems()

			local addbar = Turbine.UI.MenuItem( "Add Bar" );
			addbar.Click = function( sender, args )
				PopUpsaddbar()
			end

			local deletebar = Turbine.UI.MenuItem( "Delete "..PopUps[i].options.name,(NumberOfBars>1));
			deletebar.Click = function( sender, args )
				PopUpsdeletebar(i)
			end

			contextMenu.SubMenuItems:Add(addbar)		
			contextMenu.SubMenuItems:Add(deletebar)

	local RotationMenu=Turbine.UI.MenuItem("Pop out...")
		contextMenu.SubMenu2=RotationMenu:GetItems()
			local popoutleft=Turbine.UI.MenuItem("Left",true,PopUps[i].options.orientation=="r")
			popoutleft.Click=function (sender, args) PopUps[i]:Change (0,"r")  end
			
			local popoutright=Turbine.UI.MenuItem("Right",true,PopUps[i].options.orientation=="l")
			popoutright.Click=function (sender, args) PopUps[i]:Change (0,"l")  end
			
			local popoutup=Turbine.UI.MenuItem("Up",true,PopUps[i].options.orientation=="b")
			popoutup.Click=function (sender, args) PopUps[i]:Change (0,"b")  end
			
			local popoutdown=Turbine.UI.MenuItem("Down",true,PopUps[i].options.orientation=="t")
			popoutdown.Click=function (sender, args) PopUps[i]:Change (0,"t")  end
			
			contextMenu.SubMenu2:Add(popoutleft)
			contextMenu.SubMenu2:Add(popoutright)
			contextMenu.SubMenu2:Add(popoutup)
			contextMenu.SubMenu2:Add(popoutdown)
			
	local fademenu = Turbine.UI.MenuItem( "Fade Button "..PopUps[i].options.name,true,PopUps[i].options.fade);
		fademenu.Click = function( sender, args )
			PopUps[i].options.fade=true
			SetOpacityEvent(i)
		end				

		contextMenuItems:Add( addsubMenuItem )
		contextMenuItems:Add( takesubMenuItem )
		
		contextMenuItems:Add( BarMenuItem )
		contextMenuItems:Add( RotationMenu )
		contextMenuItems:Add( fademenu )
		contextMenu:ShowMenu();
	end
end 

function PopUpsaddbar ()
--Increase the number of bars and add a new bar. By default it appears nudged in from the bottom right.
	NumberOfBars=NumberOfBars+1
	local i=NumberOfBars
	PopUps[i]=NewQPopUpBar{x=SW-36*i,y=SH-36*6,orientation="b",length=5,dragbar=true,name="Pop Up "..i}
	PopUpsAddButton(i)
	PopUps[i].button:SetVisible(true)
	--Tell the bar we are unlocked
	PopUps[i].Window.DragBar:ToggleDraggable( )
	--Set up the opacity events
	SetOpacityEvent(i)
end

function PopUpsdeletebar(i)
--Delete a popupbar
	--This is WAY, WAY overkill - but table.remove(PopUps,i) does not remove the complete object, unlike when working with BevyBars. Why? I have no idea!
	for j=1,#PopUps[i].Quickslot do
		PopUps[i].Quickslot[1]:SetVisible(false)
		table.remove(PopUps[i].Quickslot,1)
	end
		
	PopUps[i].Window:SetVisible(false)
	PopUps[i].Window.DragBar:SetVisible(false)
	PopUps[i].Window.DragBar=nil
	PopUps[i].Window=nil
	table.remove(PopUps,i) --I do not think this is actually deleting the table - and I have no idea why! Some elements seem to be deleted, but not others.

	NumberOfBars=NumberOfBars-1
	
	for j = i, NumberOfBars do -- Here as well this was not nessecery. With Bevybars I could just go from i to NumberOfBars...
		--Reassign names.
			PopUps[j].options.name="PopUp "..j
		--Reassign Dragbar names.
			PopUps[j].Window.DragBar.sName =PopUps[j].options.name
			PopUps[j].Window.DragBar.Label:SetText( PopUps[j].options.name );
		--Re-do Opacity events.
			SetOpacityEvent(j)
		--Final problem - the buttons point to the wrong place now. Need to re-assign events
			PopUpsButtonEvents(j)
	end
end

function save()
--Save all the bar information. Hopefully!
	--Do not save if loading
	if loading==1 then
		return
	end
	for i = 1,NumberOfBars do
		PopUps[i].Shortcut=PopUps[i].Quickslot:StoreSlots()
	end
	Turbine.PluginData.Save( Turbine.DataScope.Character, "PopUps", PopUps );
end

function load()

--Load back in all the bar info

	--Disable saving whilst loading.
	loading = 1	
	--Here we get the results of the save and save into a temp file.
	PopUpsTemp=Turbine.PluginData.Load( Turbine.DataScope.Character, "PopUps")
	
	--Test to see if there was no data
	if type(PopUpsTemp)~="table" then
	--Load defaults then!
		--Defaults. 5 bars, 5 slots each, pointing up, in the bottom right hand corner.
			NumberOfBars=5
			PopUps={}
			for i=1 , NumberOfBars do
				PopUps[i]=NewQPopUpBar{x=SW-36*i,y=SH-36*6,orientation="b",length=5,dragbar=true,name="Pop Up "..i}
				PopUpsAddButton(i) -- Add the modifier button
				PopUps[i]:Close()	--Fold it back in
				PopUps[i].options.fade=false
				SetOpacityEvent(i) --Set up opacity events
			end
			loading = 0
			return --Nothing more to see here... move along.
	end

	--Get NumberOfBars
	PopUps={}
	NumberOfBars = table.getn(PopUpsTemp) ;-- This does NOT work as, occaisonally, a blank bar gets through.
	for i=1, NumberOfBars do
		--This line attempt to solve this error by reducing number of bars
		if PopUpsTemp[i].options==nil then NumberOfBars=i-1 break end
	end

	for i=1 , NumberOfBars do

		PopUps[i]=NewQPopUpBar(PopUpsTemp[i].options)
		PopUpsAddButton(i) -- Add the modifier button
		PopUps[i].Quickslot:LoadSlots(PopUpsTemp[i].Shortcut)
		if PopUpsTemp[i].Shortcut~=nil then PopUps[i].Quickslot:LoadSlots(PopUpsTemp[i].Shortcut) else JackdawPlugins.Libs.echo ("No Bar data saved") end
		PopUps[i]:Close()	--Fold it back in
		if PopUpsTemp[i].options.fade==nil then PopUps[i].options.fade=false else PopUps[i].options.fade=PopUpsTemp[i].options.fade end -- if this is nil, set it to false. Just in case...
		SetOpacityEvent(i) -- Setup opacity events
	end
	loading=0
end	

--Event Handler setter
--**********************
--Opacity is handled much simpler in this plugin as opposed to Bevy.
--It is assumed that skills in pop-up bars are not the type that tend to be used in combat, so there is no combat handler.
--This sets the opacity events for all pop-upbuttons
--Also sets the opacity NOW to whatever
function SetOpacityEvent(i)
	--Have to set this once...
		local popbuttonindex=PopUps[i].options.popbuttonindex
			PopUps[i].Window.MouseEnter = function ( sender, args)
				SetOpacity(i,1)
			end
			
			PopUps[i].Window.MouseLeave = function ( sender, args)
				if PopUps[i].options.fade then
					SetOpacity(i,faded)
				else
					SetOpacity(i,1)
				end
			end
			--Opacity NOW is faded... or not.
			if PopUps[i].options.fade then
				SetOpacity(i,faded)
			else
				SetOpacity(i,1)
			end
end

--Opacity Function
--******************
--This sets the opacity of PopUps[i] to o; the window and all its quicklsots
function SetOpacity(i,o)
	local popbuttonindex=PopUps[i].options.popbuttonindex
	PopUps[i].Window:SetOpacity(o)
end

function globalopacityevent()
for i=1 , NumberOfBars do
	SetOpacityEvent(i)
end
end

