--Notes for all libraries:
--In some of the functions concerning quickslots there is an arbirary -2 which seems to help centre the slots. Adjust as nessecary using search and replace.
--In concept these libs deal with creating a SINGLE bar/popup. If you create multiple objects and wish to delete/rename them then your plugin will need to handle this!
--Some 'SetShortcut's run through pcall to avoid errors being thrown up by items you no loner have. - Thanks Pengoros!
	
 --[[***echo***
 A quick function to echo things to the command line. Saves remembering Turbine.Shell.Writeline()]]--
	 function echo (var)
		Turbine.Shell.WriteLine(var)
	 end
	
--[[**Delete***
attempts to delete all entries of a table and thus delete an object]]--
function Delete(t)
	for k in pairs(t) do 
		t[k]=nil
	end
end

--[[**PSetShortcut***
Uses pcall to avoid an error if the shortcut is invalid]]--

function PSetShortcut(target,source)
	pcall(function () target:SetShortcut(source) end)
end

--[[**DeepCopy
Copies a table - completely and in a "Deep" way.
And LITERALLY - objects and all.
I do not pretend to understand the code of this.

From http://lua-users.org/wiki/CopyTable]]
function deepcopy(object)
    local lookup_table = {}
    local function _copy(object)
        if type(object) ~= "table" then
            return object
        elseif lookup_table[object] then
            return lookup_table[object]
        end
        local new_table = {}
        lookup_table[object] = new_table
        for index, value in pairs(object) do
				new_table[_copy(index)] = _copy(value)
        end
        return setmetatable(new_table, getmetatable(object))
    end
    return _copy(object)
end