import "Turbine.UI.Lotro";

--[[***NewQuickslot***
	 Create a new quickslot
	 Example use; MyQuickslot = NewQuickslot {x=10,y=10,parent=mywindow} NOTE THE CURLY BRACKETS!
	 Options;
		 x,y coordinates	Default to 0
		 visible				Default to 1
		 opacity				Default to 1
		 parent					Mandatory
		 size					LEAVE FOR NOW -- Turbine do not allow us to change the size yet]]--
	NewQuickslot=class (Turbine.UI.Lotro.Quickslot)
	function NewQuickslot:Constructor (options)
		Turbine.UI.Lotro.Quickslot.Constructor(self);
		self :SetPosition			( options.x or 0,options.y or 0)
		self :SetVisible			( options.visible or 1 )
		self :SetOpacity			( options.opacity or 1 )
		self:SetParent				( options.parent );
		self:SetSize				(options.size or 35,options.size or 35);

		--Right swopping code!

		--I owe D1Hicks a debt for the original ideas behind this.

		self.MouseDown = function(sender,args)
			--Set two global variables when we begin to drag a quickslot.
				shortcutfrom=self								--This is where the shortcut is coming FROM	
				draggingShortcut=false						--The shortcut is NOT being dragged around, only clicked.
		end

		self.DragEnter = function(sender,args)
			draggingShortcut = true;						--We *are* dragging a shortcut, because we entered another quicklsot.
			targetshortcut=self:GetShortcut()		--If we enter a quickslot then store it's shortcut ready for a swop operation.
		end
		
		self.ShortcutChanged=function(sender,args)
			--If we are dragging a shortcut, and this shortcut changes then set the source with the destination. I.E. a swop!
				if draggingShortcut then
					if shortcutfrom ~=nil then
						shortcutfrom:SetShortcut(targetshortcut)
						targetshortcut=nil; shortcutfrom=nil; draggingShortcut=false
					end
				end
		end
		
		self.DragDrop= function(sender,args)
			--echo("Never fires - when it does it is time to fix the drag behaviour with a much simpler solution!")
		end
	end	