import "Turbine"
import "Turbine.UI";
import "Turbine.Utils";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";

import "JackdawPlugins.Libs.Common"

import "JackdawPlugins.Libs.Buttons"

import "JackdawPlugins.PopUps.function"
import "JackdawPlugins.PopUps.QPopUps"

import "Deusdictum.UI.Dragbar"

--[[
		Pop-Up Quickslots
		********************
		
		What is it?
		************
		Pop-Up Quickslots provides the player with more quickslot bars that "pop up" when right clicked.
		Abilities/items can be slotted on these bars. When the abilites are clicked (or right clicked) they are copied to the button at the end and the bar 'rolls' back in.
		
		When the screen is unlocked a button becomes available that allows many modifications to be made -
			*	More/less bars
			*	More/less slots
	
		The two screenshots below show this, but it is best to load her up and play!
		
		NOTE: This plugin *requires* Deusdictum's Dragbar class to be installed.
		
		KNOWN BUGS:
			*	The plugin can't detect if display is unlocked when the plugin is loaded. So, make sure it is locked before you start!
			*	If you change the screen resolution you can lose sight of the bars.

		What is left to do?
		*********************
		NOTE: I do not intend to fix the bugs above as of now! These changes are also low on my list of priorities...
		
		* Add a backdrop to show which way the button 'pops'
		* Micro-positioning - Bars that lock together - I am unsure how to do this however?
		
		Thanks to: Deusdictum, Pengoros and TheOldOne!
		Special thanks: D.H1cks for his quickslot code.
]]--
		
	JackdawPlugins.Libs.echo("PopUps version 3.1 by MrJackdaw - enjoy!")	
	
--Begin

	--Standard variables
	SW,SH=Turbine.UI.Display.GetSize() -- size of the display
	faded=0.5	--hard coded opacity for *all* faded PopUpButtons. Yes, all the same thankyouverymuch
	--load the settings, or set to defaults.				
	load()
	
--Save events.
	--First one, registered to the button on PopUp[1], saves when the UI is locked.
	--Second ; save on Unload. Thanks ForsakenArcher!
	-- Due to a bug in the Turbine code this is currently hidden in the assignbutton function - get it out of there when they fix the code!
	set=false --Clear this line when the bug is fixed
	--[[if ( Plugins ["PopUps"] ~= nil ) then
		Plugins["PopUps"].Unload = function( sender, args )
			save()
			JackdawPlugins.Libs.echo("Thank you for using Pop Up Bars!")
		end
	end]]--